//
//  ViewController.swift
//  LazyVarCompilerSegfault
//
//  Created by Darren Clark on 2016-10-11.
//

import UIKit

class ViewController: UIViewController, MyProtocol {

    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    // MARK: -

    // Compiler crash is related to this property (also see MyProtcol.swift).  There is a workaround
    // commented out below.  Additionally, this can be fixed by removing @objc from MyProtocol
    lazy var myView: UIView? = {
        let myView = UIView()
        myView.backgroundColor = .red
        return myView
    }()

    // Temporary Workaround:
//    lazy var myView_: UIView? = {
//        let myView = UIView()
//        myView.backgroundColor = .red
//        return myView
//    }()
//
//    var myView: UIView? {
//        return myView_
//    }
}

